%this works out examples of polynomial interpolation of 
%ip = 1: the function f(k)=1/(1+k^2), for k belonging to -5,5.
%ip = 2: the function f(k)=sqrt(k), for k belonging to 0,1.
%ip = 3: the function f(k) = max{k , 1 - .36 + .36*k}
%ip = 4: the function f(k) = max{0,5*k}.
%to get the graph in the PEA paper, set ip=1, M=11, and execute this program.


ip=1;
if ip == 1
 M=11;
 klo=-5;
 kup=5;
 k=-5:.05:5;
end
if ip == 2
 klo=0;
 kup=1;
 k=0:.01:1;
end
if ip == 3
 klo = 0;
 kup = 10;
 k=0:.01:10;
end
if ip == 4
  M=100;
  klo=-1;
  kup=1;
  k=-1:.01:1;
end


sa=zeros(M,1);
ca=sa;
[ca,sa,kkap,kkbp] = cinterp(klo,kup,'dutta',M,ip);
[f15,fh15] = csmooth(ca,'dutta',klo,kup,M,k,ip);
if ip ~= 4 
  [fl15,fhl15] = smooth(sa,'dutta',klo,kup,M,k,ip);
end
errc15=f15-fh15;
if ip == 4 
  plot(k,f15-fh15)
  break
end
errl15=fl15-fhl15;

fc=ones(size(kkap))*(-.2);
fl=ones(size(kkbp))*(-.5);
subplot(212)
plot(k,f15,k,fh15,'--',kkap,fc,'*')
title('Function Approximation with Chebyshev Zeros')
xlabel('k')
if ip == 1
text(-3,.5,'f(k)=1/(1+k*k)')
text(.8,.9,'Approximating Function')
end
subplot(211)
plot(k,fl15,k,fhl15,'--',kkbp,fl,'*')
title('Function Approximation With Fixed Interval Grid')
xlabel('k')
if ip == 1
text(-4.1,.5,'f(k)=1/(1+k*k)')
text(.9,1.5,'Approximating Function')
end
break
errlinear=fh15-fl15;
errcheb=fh15-f15;
tt=20:length(k)-20;
subplot(223)
plot(k(tt),errlinear(tt),k(tt),errcheb(tt))
title('Actual function value minus approximating function')

